import parmed as pmd
import numpy as np
#import nglview as nv

amber = pmd.load_file('AMBER/SYSTEM.top', 'AMBER/SYSTEM.crd')

# Save a GROMACS topology and GRO file
#amber.save('gromacs.top', overwrite=True)
#amber.save('gromacs.gro', overwrite=True)

hostguest_original=amber["!(:WAT)"]
hostguest_original=hostguest_original["!(:Na+)"]

# Save a CHARMM PSF and crd file
hostguest_original.save('CHARMM/charmm.psf', overwrite=True,)
hostguest_original.save('CHARMM/charmm.pdb', overwrite=True)
pmd.charmm.CharmmParameterSet.from_structure(hostguest_original).write(top='CHARMM/charmm.rtf', par='CHARMM/charmm.prm')

from vmd import evaltcl
ions = evaltcl("source scripts/solvateTemplate.tcl")

solvated = pmd.load_file('CHARMM/solvated.pdb', 'CHARMM/solvated.psf')
solvent=solvated["(:TIP3)"]
solvent.save('CHARMM/solvent.psf', overwrite=True,)
solvent.save('CHARMM/solvent.pdb', overwrite=True)


ions = evaltcl("source scripts/merge_protein_and_solvent_box.tcl")

solvated = pmd.load_file('CHARMM/solvated.pdb', 'CHARMM/solvated.psf')

fixedRes = [r for r in solvated.residues if r.name=="OCB" or r.name=="MOL"]
print("fix ",fixedRes)
for r in fixedRes:
	for a in r.atoms:
		a.occupancy=1.0
		a.bfactor=1.0
		
solvated.save('CHARMM/solvated.psf', overwrite=True,)
solvated.save('CHARMM/solvated.pdb', overwrite=True)
pmd.charmm.CharmmParameterSet.from_structure(solvated).write(top='CHARMM/charmm.rtf', par='CHARMM/charmm.prm')
